/*
 * Copyright (C) 2001-2002 WarKnite Computers.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include "struct.h"

int do_kill(char *source, char *nick, char *why)
{
   send_to_client(curconn->fd,":%s KILL %s :%s %s\n",source,nick,source,why);
}

int do_kline(time_t seconds, char *ident, char *host, char *why)
{
   send_to_client(curconn->fd,":%s KLINE * %lu %s %s :%s\n",security->nick,seconds,ident,host,why);
}


/* argv[0] == nick | nick!user@host
 * argv[1] == time (hours)
 * argv[2] == :why
 */

int command_kline(char *source, PARAMS)
{
   int time=0,err=1;
   char *nick, *user, *host, temp[512];

   if (argc == 3)
   {
      time = atoi(argv[1]);
      if (!time) err = 1;
      else time *= 3600;

      if (index(argv[0],'!'))
      {
         strcpy(temp,argv[0]);
         split_usermask(temp,&nick,&user,&host);
         if (host[strlen(host)-1] == '*') err = 2;
         else if (host[strlen(host)-1] == '?') err = 2;
         else do_kline(time,user,host,argv[2]);
         free(nick); free(user); free(host);
      }
      else
      {
         curuser = find_nick(argv[0]);
         if (!curuser) err = 3;
         else
         {
            do_kline(time,curuser->user,curuser->host,argv[2]);
         }
      }
   }
   else err = 1;

   switch (err)
   { 
      case 1:
         notice(source,"Usage: kline <nick|hostmask> <hours> :<why>");
         break;

      case 2:
         notice(source,"You can't kline top level domains");
         break;
      
      case 3: 
         notice(source,"No such nick %s",argv[0]);
         break;

      default:
         notice(source,"Klined %s",argv[0]);
         break;
   }
}
