/*
 * Copyright (C) 2001-2002 WarKnite Computers.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include "struct.h"

void debug(char *type, char *format, ...)
{
   va_list va; char buffer[1024];
   va_start(va,format); vsnprintf(buffer, 1024, format, va); va_end(va);

#ifdef DEBUG
   if (strlen(buffer) == 0) printf("[%-7s] Buffer Empty\n", "Error"); /* Sanity Check */
   else printf("[%-7s] %s\n",type,buffer);
#endif

   if (!burst)
   {
       if (strlen(buffer) == 0) privmsg("#dump","[%-7s] Buffer Empty\n", "Error");
       else privmsg("#dump","[%-7s] %s",type,buffer);
   }
}

int count_servers(char *chan)
{
   SERVPTR serv;
   int hub=0, leaf=0;
   
   for (serv = servhead; serv; serv = serv->next)
   {
      if (serv->down) hub++;
      else leaf++;
   }
   notice(chan,"Hubs: %d Leafs: %d Total Servers: %d",hub,leaf,hub+leaf);

}

void dump_serv_list(char *chan)
{
   Server *c;
   c = servhead;

   notice(chan,"----------- Serv List ------------");

   while (c)
   {
      notice(chan," ");
      notice(chan,"Name: %s",c->name);
      notice(chan,"Info: %s",c->info);
      if (c->up) notice(chan,"Uplink: %s",c->up->name);
      if (!c->prev) notice(chan,"Next: %s",c->next->name);
      else if (!c->next) notice(chan,"Prev: %s",c->prev->name);
      else notice(chan,"Next: %s Prev: %s",c->next->name,c->prev->name);
      notice(chan," ");
      notice(chan,"----------------------------------");
      c = c->next;
   }
}

void dump_serv_user_list(char *chan, SERVPTR serv)
{
   Link *c;
   int x = 1;

   c = serv->userhead;

   if (c) notice(chan,"------- Users on server %s -------",serv->name);
   else notice(chan,"No Users on server %s",serv->name);

   while (c)
   {
      notice(chan,"%d. %s!%s@%s",x,c->value.user->nick,c->value.user->user,c->value.user->host);
      x++;
      c = c->next;
   }
}

void dump_chan_list(char *chan)
{
   Channel *c;
   c = chanhead;

   notice(chan,"----------- Chan List ------------");

   while (c)
   {
      notice(chan," ");
      notice(chan,"Name: %s",c->name);
      notice(chan,"TS: %lu",c->timestamp);
      if (!c->prev) notice(chan,"Next: %s",c->next->name);
      else if (!c->next) notice(chan,"Prev: %s",c->prev->name);
      else notice(chan,"Next: %s Prev: %s",c->next->name,c->prev->name);
      notice(chan," ");
      notice(chan,"----------------------------------");
      c = c->next;
   }
}

void dump_user_list(char *chan)
{
   User *c;
   char *temp;
   c = userhead;

   notice(chan,"----------- User List ------------");

   while (c)
   {
      notice(chan," ");
      notice(chan,"User: %s!%s@%s",c->nick,c->user,c->host);
      notice(chan,"Realname: %s",c->info);
      notice(chan,"TS: %lu",c->timestamp);
      notice(chan,"Server: %s",c->server->name);
      if (!c->prev) notice(chan,"Next: %s",c->next->nick);
      else if (!c->next) notice(chan,"Prev: %s",c->prev->nick);
      else notice(chan,"Next: %s Prev: %s",c->next->nick,c->prev->nick);
      notice(chan," ");
      notice(chan,"----------------------------------");
      c = c->next;
   }
}

void dump_chan_users(char *channel, char *target, int type)
{
   CHANPTR chan;
   Link *User;
   char buffer[512];
   int sendit=0,i=0;

   if (!(chan = find_channel(channel)))
   {
       notice(target,"No such channel %s",channel);
       return;
   }
   else
   {
       if (!type) notice(target,"Channel %s has User list:",channel);
       else if (type==1) notice(target,"Channel %s +o list:",channel);
       else if (type==2) notice(target,"Channel %s +v list:",channel);
       else if (type==3) notice(target,"Channel %s +h list:",channel);
       User = chan->userhead;
       while (User)
       {
           sendit=0;
           memset(buffer,0,sizeof(buffer));
           while ((User) && (strlen(buffer) < 400))
           {
               sendit++;
               switch(type)
               {
                   case 0:
                      if (IsOped(User)) strcat(buffer,"@");
                      else if (IsHalfop(User)) strcat(buffer,"%");
                      else if (IsVoice(User)) strcat(buffer,"+");
                      strcat(buffer,User->value.user->nick);
                      strcat(buffer," ");
                      i++;
                      break;

                   case 1:
                      if (IsOped(User))
                      {
                           strcat(buffer,"@");
                           strcat(buffer,User->value.user->nick);
                           strcat(buffer," ");
                           i++;
                      }
                      break;

                   case 2:
                      if (IsVoice(User))
                      {
                           strcat(buffer,"+");
                           strcat(buffer,User->value.user->nick);
                           strcat(buffer," ");
                           i++;
                      }
                      break;

                   case 3:
                      if (IsHalfop(User))
                      {
                           strcat(buffer,"%");
                           strcat(buffer,User->value.user->nick);
                           strcat(buffer," ");
                           i++;
                      }
                      break;


                   default:
                      break;
               }

               User = User->next;
           }
           if (sendit) notice(target,"%s",buffer);
       }
   }
   switch(type)
   {
       case 0:
           notice(target,"%s has %d users",channel,i);
           break;

       case 1:
           notice(target,"%s has %d ops",channel,i);
           break;

       case 2:
           notice(target,"%s has %d voices",channel,i);
           break;

       case 3:
           notice(target,"%s has %d halfops",channel,i);
           break;

       default:
           break;
   }
}

void dump_user_chans(char *nick, char *chan)
{
   USERPTR user;
   Link *Chan;
   char buffer[512];
   int sendit=0;

   if (!(user = find_nick(nick)))
   {
       notice(chan,"No such user %s",nick);
       return;
   }
   else
   {
       notice(chan,"%s is on channels:",nick);
       Chan = user->chanhead;
       while (Chan)
       {
           sendit=0;
           memset(buffer,0,sizeof(buffer));
           while ((Chan) && (strlen(buffer) < 400))
           {
               sendit++;
               if (IsOped(Chan)) strcat(buffer,"@");
               else if (IsHalfop(Chan)) strcat(buffer,"%");
               else if (IsVoice(Chan)) strcat(buffer,"+");
               strcat(buffer,Chan->value.chan->name);
               strcat(buffer," ");
               Chan = Chan->next;
           }
           if (sendit) notice(chan,"%s",buffer);
       }
   }
}

#ifdef HASHWATCH
void hash_values(char *chan)
{
  unsigned int channels=sizeof(Channel) * myhash.channels;
  unsigned int servers=sizeof(Server) * myhash.servers;
  unsigned int users=sizeof(User) * myhash.users;
  unsigned int links=sizeof(Link) * myhash.links;
  unsigned int services=sizeof(Services) * myhash.services;
  unsigned int nickuser=sizeof(Nickuser) * myhash.nickuser;
  unsigned int total=channels+servers+users+links+services+nickuser;

  notice(chan,"(%d) channels (%d bytes) in memory",myhash.channels,channels);
  notice(chan,"(%d) users (%d bytes) in memory",myhash.users,users);
  notice(chan,"(%d) servers (%d bytes) in memory",myhash.servers,servers);
  notice(chan,"(%d) services (%d bytes) in memory",myhash.services,services);
  notice(chan,"(%d) nicks registered (%d bytes) in memory",myhash.nickuser,nickuser);
  notice(chan,"(%d) links (%d bytes) in memory",myhash.links,links);
  notice(chan,"%d bytes total",total);
}
#endif


