/*
    Taken from EnergyMech, IRC bot software
    Parts Copyright (c) 1997-2001 proton

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <stdio.h>
#include "defines.h"

char    pctab[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuwvxuz0123456789+-";

#define CIPHER(a1,a2,a3,a4,b1,b2,b3,b4) \
{                                       \
        a2 =  a2 ^  a1;                 \
        b2 =  b2 ^  b1;                 \
        a3 =  a2 ^  a1;                 \
        b3 =  b2 ^  b1;                 \
        b3 >>= 2;                       \
        b3 |= ((a3 & 3) << 30);         \
        a3 >>= 2;                       \
        a2 =  a3 ^  a2;                 \
        b2 =  b3 ^  b2;                 \
        a4 = ~a4 ^  a2;                 \
        b4 = -b4 ^  b2;                 \
        a2 =  a4 ^ ~a2;                 \
        b2 =  b4 ^ -b2;                 \
        b1 >>= 1;                       \
        b1 |= ((a1 & 1) << 31);         \
        a1 >>= 1;                       \
}

char *cipher(char *arg)
{
        static  char res[40];
        unsigned long   B1a,B2a,B3a,B4a;
        unsigned long   B1b,B2b,B3b,B4b;
        unsigned char   *ptr;
        unsigned long   R1;
        int     i;

        if (!arg || !*arg)
                return(NULL);

        B1a = B2a = B3a = B4a = 0;
        B1b = B2b = B3b = B4b = 0;
        ptr = arg;

        while(*ptr)
        {
                R1 = *ptr;
                for(i=0;i<8;i++)
                {
                        if (R1 & 1)
                        {
                                B1a |= 0x80008000;
                                B1b |= 0x80008000;
                        }
                        R1  >>= 1;
                        CIPHER(B1a,B2a,B3a,B4a,B1b,B2b,B3b,B4b);
                }
                ptr++;
        }
        while((B1a) || (B1b))
        {
                CIPHER(B1a,B2a,B3a,B4a,B1b,B2b,B3b,B4b);
        }

        memset(res,0,sizeof(res));
        i = 0;
        for(i=0;i<10;i++)
        {
                res[i] = pctab[(B4b & 0x3f)];
                B4b >>= 6;
                B4b |= ((B4a & 0x3f) << 26);
                B4a >>= 6;
        }
        return(res);
}

int makepass(char *encoded, char *plain)
{
    strcpy(encoded,cipher(plain));
}

char *encrypt(char *plain)
{
    return cipher(plain);
}

int checkpass(char *plain, char *pass)
{
  if (!strcasecmp(cipher(plain),pass)) return 1;
  else return 0;
}
