/*
 * Copyright (C) 2001-2002 WarKnite Computers.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * 
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

#define MAIN_C_

#include <signal.h>
#include "struct.h"

char codename[10]="security";
char version[7]="0.2.1a";
int running=1;

void null() {}

void death()
{
   debug("Death","Closing All Open Sockets");
   debug("Death","%s Exited Successfully!",codename);
   exit(0);
}

void hup()
{
   debug("HUP","SIGHUP");
   death();
}

void segv()
{
   debug("Segv","ACK! Segmentation Fault");
   death();
}

int main(int argc, char *argv[])
{
#ifndef DEBUG
   FILE *fp;
#endif
   char temp[512];
   int pid;
   time_t last_timeout = time(NULL);

   (void)signal(SIGSEGV,segv);
   (void)signal(SIGINT,death);
   (void)signal(SIGTERM,death);
   (void)signal(SIGHUP,hup);
   (void)signal(SIGPIPE,SIG_IGN);

   setvbuf(stdout, NULL, _IONBF, 0);

#ifndef DEBUG
   pid = fork();
   switch (pid)
   {
        case -1:
           printf("Unable to fork(), exiting.\n");
           exit(0);

        case 0:
           break;

        default:
           sprintf(temp,"%s.pid",argv[0]);
           fp = fopen(temp,"w");
           if (fp)
           {
              fprintf(fp,"%d\n",pid);
              (void)fclose(fp);
           }
           printf("%s v%s Starting... (pid: %d)\n",codename,version,pid);
           exit(0);
   }
#else
   printf("%s v%s Starting...\n",codename,version);
#endif

   register_connection(SOCK_OFFLINE,SOCK_UPLINK);
   me = register_server("security.tfnet.net","Security",0,NULL);
   assert(me);

   init_services();

   while(running)
   {
      do_select();

      if (now-last_timeout >= TIMEOUT_CHECK)
      {
         check_timeouts();
         last_timeout = now;
      }
   }
   death();
}
