/************************************************************************
 *   IRC - Internet Relay Chat, ircd/s_ping.c
 *   Copyright (C) 1994 Carlo K ( Run @ undernet.org )
 *   Map functions slightly modified 2001 by WarKnite(WarKnite@warknite.com)
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "struct.h"

void dump_map(SERVPTR server, int prompt_length, char *user)
{
  static char prompt[64];
  Link *lp;
  char *p = &prompt[prompt_length];
  int cnt = 0, users = 0;
  *p = '\0';

  if (prompt_length > 60) return;
  for (lp = server->userhead; lp; lp = lp->next) users++;
  notice(user,"%s%s [%d users]",prompt,server->name,users);

  if (prompt_length > 0)
  {
    p[-1] = ' ';
    if (p[-2] == '`') p[-2] = ' ';
  }
  strcpy(p, "|-");
  for (lp = server->down; lp; lp = lp->next) cnt++;
  for (lp = server->down; lp; lp = lp->next)
  {
    if (cnt-- == 0) *p = '`';
    dump_map(lp->value.serv, prompt_length+2,user);
  }
  if (prompt_length > 0) p[-1] = '-';
}

void do_map(char *user)
{
  SERVPTR serv;
  
  for (serv = me; serv->up; serv = serv->up);

  notice(user,"Map for %s",serv->name);
  dump_map(serv,0,user);
  notice(user," ");
  notice(user,"End of Map.");
}
