/* do_match_wild, match_wild, split_usermask, and create_mask
 * taken from Services NN-1.3 1988 release version.
 *
 * tokenize made by ohsix@efnet for use with TFbot and my other projects
 */

#include "struct.h"

int tokenize(char *the_string, char **argv, int argvsize, int *argc, int ignore_colons)
{
    char *c = the_string;
    int token = 0;

    while(*c)
    {
        argv[token] = c;
        *argc = token;
        token++;

        if (token > argvsize)
        {
           return 0;
        }

        while (!isspace(*c))
        {
            if (!*c) break;
            if (*c == ':' && !ignore_colons)
            {
                *c = 0;
                c++;
                token;
                argv[token-1]++;
                *argc = token;
                return 1;
             }
            c++;
        }

        while(isspace(*c))
        {
                *c = 0;
                c++;
        }
   }
   *argc = token;
   return 1;
}

static int do_match_wild(const char *pattern, const char *str, int docase)
{
  char c;
  const char *s;

  for (;;)
  {
    switch (c = *pattern++)
    {
      case 0:
        if (!*str) return 1;
        return 0;
      case '?':
        if (!*str) return 0;
        ++str;
        break;
      case '*':
        if (!*pattern) return 1;
        s = str;
        while (*s)
        {
          if ((docase ? (*s == *pattern) : (tolower(*s) == tolower(*pattern)))
            && match_wild(pattern, s)) return 1;
          ++s;
        }
        break;
      default:
        if (docase ? (*str++ != c) : (tolower(*str++) != tolower(c))) return 0;
        break;
    }
  }
}

int match_wild(const char *pattern, const char *str)
{
  return do_match_wild(pattern, str, 0);
}

void split_usermask(const char *mask, char **nick, char **user, char **host)
{
  char *mask2 = NULL;
  char *p;

  mask2 = strdup(mask);

  if (!(p = strchr(mask2, '!')))
  {
    *user = mask2;
    *nick = NULL;
  }
  else
  {
    if (p == mask2) *nick = NULL;
    else *nick = mask2;
    *p++ = '\0';
    *user = p;
  }

  if (!(p = strchr(*user, '@')))
  {
    *host = *user;
    *user = NULL;
  }
  else
  {
    if (p == *user) *user = NULL;
    *p++ = '\0';
    *host = p;
  }

  if (!(p = strchr(*host, '.'))) *host = NULL;
  if (!*nick) *nick = "*";
  if (!*user) *user = "*";
  if (!*host) *host = "*";

  *nick = strdup(*nick);
  *user = strdup(*user);
  *host = strdup(*host);


  free(mask2);
}

char *create_mask(USERPTR u)
{
   char *s, *p, *q, *mask;

   s = malloc(strlen(u->user) + strlen(u->host) + 2);
   sprintf(s, "%s@%s", u->user, u->host);

   p = strchr(s, '@');
   q = strchr(p, '.');

  if ((q == NULL) || (strchr(q + 1, '.') == NULL));
  else if ((s[strlen(s) - 1] >= '0') && (s[strlen(s) - 1] <= '9'))
  {
     q = strrchr(s, '.');
     if (q != NULL) strcpy(q, ".*");
  }
  else if (q != NULL)
  {
     *(p + 1) = '*';
     strcpy(p + 2, q);
  }
  mask = strdup(s);
  free(s);

  return mask;
}
