/*
 * Copyright (C) 2001-2002 WarKnite Computers.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include "struct.h"

int parse_security(PARAMS)
{
   SERVPTR serv;
   char temp[512];

   sprintf(temp,"%s!%s@%s",curuser->nick,curuser->user,curuser->host);

   if (match_wild("*!*war@*",temp))
   {
      if (!strcasecmp(argv[0],"map")) do_map(curuser->nick);
      else if (!strcasecmp(argv[0],"kline")) command_kline(curuser->nick,argc-1,argv+1);
      else if (!strcasecmp(argv[0],"raw")) send_to_client(curconn->fd,"%s\n",temp+4);
      else if (!strcasecmp(argv[0],"servers")) count_servers(curuser->nick);
      else if (!strcasecmp(argv[0],"help")) notice(curuser->nick,"Security help not yet implemented.");
      else if (!strcasecmp(argv[0],"serv")) dump_serv_list(curuser->nick);
      else if (!strcasecmp(argv[0],"hash")) hash_values(curuser->nick);
      else if (!strcasecmp(argv[0],"chan")) dump_chan_list(curuser->nick);
      else if (!strcasecmp(argv[0],"user")) dump_user_list(curuser->nick);
      else if (argc != 2)
      {
         notice(curuser->nick,"Unknown command.");
         return;
      }
      else if (!strcasecmp(argv[0],"chans")) dump_user_chans(argv[1],curuser->nick);
      else if (!strcasecmp(argv[0],"users")) dump_chan_users(argv[1],curuser->nick,0);
      else if (!strcasecmp(argv[0],"voices")) dump_chan_users(argv[1],curuser->nick,2);
      else if (!strcasecmp(argv[0],"ops")) dump_chan_users(argv[1],curuser->nick,1);
      else if (!strcasecmp(argv[0],"halfops")) dump_chan_users(argv[1],curuser->nick,3);
      else if (!strcasecmp(argv[0],"userlist"))
      {
         serv = find_server(argv[1]);
         if (serv) dump_serv_user_list(curuser->nick,serv);
      }
      else notice(curuser->nick,"Unknown command %s. Type \"/msg %s HELP\" for help.",argv[0],service->nick);

   }
   else
   { 
      notice(curuser->nick,"Access Denied.");
      return;
   }
}
