/*
 * Copyright (C) 2001-2002 WarKnite Computers.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include "struct.h"

fd_set read_fds,write_fds;

void find_dead_socks()
{
    CONNPTR conn;
 
    loop:

    for (conn = connhead; conn; conn = conn->next)
    {
        switch(conn->fd)
        {
             case SOCK_INVAILD:
                 debug("Error","%d is a Invaild Socket",conn->fd);
 
             case SOCK_DELETE:
                 delete_connection(conn);
                 goto loop; 

             default:
                 break;
        }
    }
}

void build_list()
{
    CONNPTR conn;

    for (conn = connhead; conn; conn = conn->next)
    {
        if (conn->fd == SOCK_OFFLINE);
        else if (conn->type == SOCK_UPLINK)
        {
            switch(conn->status)
            {
                case CN_FAILED:
                    kill_user(conn);
                    break;

                case CN_TRYING:
                    FD_SET(conn->fd,&write_fds);

                case CN_CONNECTED:
                    if ((now - conn->lasttry) > 60) kill_user(conn);

                default:
                    break;
            }
        }

        if (conn->fd == SOCK_OFFLINE)
        {
           debug("Offline","retry in %lu seconds",31-(now-conn->lasttry));

           if ((now - conn->lasttry) > 30)
           {
               connect_to_uplink(conn);
               if (conn->fd > 0) FD_SET(conn->fd,&write_fds);
           }
        }

        if (conn->fd > 0) FD_SET(conn->fd,&read_fds);
    }
}

int do_select()
{
   CONNPTR conn;
   struct timeval timeout;

   find_dead_socks();

   timeout.tv_sec = 1;
   timeout.tv_usec = 0;

   time(&now);
   FD_ZERO(&read_fds);
   FD_ZERO(&write_fds);

   build_list();

               /* we need to change this MAXFDS to highsocket + 1 */
   switch(select(MAXFDS, &read_fds, &write_fds, (fd_set *) 0, &timeout))
   {
       case -1:    /* we should do some protection here */
          break;

       case 0:
          break;

       default:
          for (conn = connhead; conn; conn = conn->next)
          {
              if (conn->fd > 0)
              {
                 if (FD_ISSET(conn->fd,&write_fds))
                 {
                    debug("Connect","{%d} uplink connection established [ASYNC]",conn->fd);
                    conn->status = CN_CONNECTED;
                    conn->lasttry = now;
                    send_to_client(conn->fd,"PASS linkit :TS\n");
                    send_to_client(conn->fd,"CAPAB :EX IE CHW KLN GLN HUB EOB AOPS HOPS\n");
                    send_to_client(conn->fd,"SERVER %s 0 :%s\n",me->name,me->info);
                    make_services(conn);
                    send_to_client(conn->fd,"EOB\n");
                 }
                 if (FD_ISSET(conn->fd,&read_fds)) deal_with_data(conn);
              }
          }
          break;
   }
}
