/*
 * Copyright (C) 2001-2002 WarKnite Computers.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include "struct.h"

extern int null(), parse_sjoin(), parse_nick(), parse_nickchange(), parse_privmsg();
extern int parse_server(), parse_quit(), parse_kill(), parse_mode(), parse_part();
extern int parse_kick(), parse_squit(), parse_error(), parse_eob(), parse_wallops();
extern int parse_operwall(), parse_away();

struct Message
{
        char *command;
        int (*function)();
};

static struct Message cmdlist[] =
{
   { "PRIVMSG",	parse_privmsg,		},
   { "MODE",	parse_mode,		},
   { "NICK",	parse_nickchange,	},
   { "MODE",	parse_mode,             },
   { "QUIT",	parse_quit,             },
   { "KICK",	parse_kick,             },
   { "SJOIN",	parse_sjoin,		},
   { "PART",	parse_part,		},
   { "SERVER",	parse_server,           },
   { "AWAY",    parse_away,             },
   { "KILL",	parse_kill,             },
   { "WALLOPS", parse_wallops,          },
   { "OPERWALL", parse_operwall,        },
   { "EOB",	parse_eob,              },
   { NULL,	null,			}
};

static struct Message numlist[] =
{
   { NULL,       null,       }
};


int server(PARAMS)
{
   int i=0;
   char *source=argv[0];
   char *type=argv[1];

   if (!strcasecmp(source,"PING")) send_to_client(curconn->fd,"%s PONG %s :%s\n",me->name,me->name,argv[1]);
   else if (!strcasecmp(source,"PASS"))
   {
      curconn->status = CN_LOGGED;
   }
   else if (!strcasecmp(source,"NICK")) parse_nick(argc,argv);
   else if (!strcasecmp(source,"SQUIT")) parse_squit(argc,argv);
   else if (!strcasecmp(source,"ERROR")) parse_error(argc,argv);
   else if (!strcasecmp(source,"SERVER"))
   {
      curserv = register_server(argv[1],argv[3],atoi(argv[2]),NULL);
      assert(curserv);
      me->up = curserv;
      register_downlink(me,curserv);
      debug("Server","%s linked to %s (%s)",me->name,argv[1],argv[3]);
   }
   else
   {
      switch(type[0])
      {
         case '0':
         case '1':
         case '2':
         case '3':
         case '4':
         case '5':
         case '6':
            for (i=0;numlist[i].command;i++)
            {
               if (!strcasecmp(type,numlist[i].command))
               {
                  numlist[i].function(argc,argv);
                  return 0;
               }
            }  
            return 1;
            break;

         default:
            for (i=0;cmdlist[i].command;i++)
            {
               if (!strcasecmp(type,cmdlist[i].command))
               {
                  cmdlist[i].function(argc,argv);
                  return 0;
               }
            }
            return 2;
            break;
      }
   }
}

int process_uplink(CONNPTR conn)
{
   char *argv[255], buffer[512];
   int argc=0;

   memset(argv,0,sizeof(argv));
   if (conn->buffer[0])
   {
      strcpy(buffer,conn->buffer);
      if (conn->buffer[0] == ':') tokenize(buffer+1, argv, 255, &argc, 0);
      else tokenize(buffer, argv, 255, &argc, 0);
      curconn = conn;
      switch(server(argc,argv))
      {
         case 1:
            debug("Numeric","%s",conn->buffer);
            break;
          
         case 2:
            debug("Buffer","%s",conn->buffer);
            break;         
      }
   }
}
