/* Taken from Services NN-1.3 1988 release version.*/

#include "struct.h"
#include "timeout.h"

static Timeout *timeouts = NULL;

/* Check the timeout list for any pending actions. */

void check_timeouts(void)
{
    Timeout *to, *to2;
    time_t t = time(NULL);

    to = timeouts;
    while (to)
    {
	if (t < to->timeout)
        {
	    to = to->next;
	    continue;
	}
	to2 = to->next;
	if (to->next) to->next->prev = to->prev;
	if (to->prev) to->prev->next = to->next;
	else timeouts = to->next;
	to->code(to);
	free(to);
	to = to2;
    }
}

/* Add a timeout to the list to be triggered in `delay' seconds. */

Timeout *add_timeout(int delay, void (*code)(Timeout *))
{
    Timeout *t = malloc(sizeof(Timeout));
    t->settime = time(NULL);
    t->timeout = t->settime + delay;
    t->code = code;
    t->next = timeouts;
    t->prev = NULL;
    if (timeouts) timeouts->prev = t;
    timeouts = t;
    return t;
}

/* Remove a timeout from the list (if it's there). */

void del_timeout(Timeout *t)
{
    Timeout *ptr;

    for (ptr = timeouts; ptr; ptr = ptr->next)
    {
       if (ptr == t) break;
    }
    if (!ptr) return;
    if (t->prev) t->prev->next = t->next;
    else timeouts = t->next;
    if (t->next) t->next->prev = t->prev;
    free(t);
}
