/* Taken Services NN-1.3 1988 release version. */

#ifndef TIMEOUT_H
#define TIMEOUT_H

#include <time.h>

/* Definitions for timeouts: */
typedef struct timeout_ Timeout;
struct timeout_
{
   Timeout *next, *prev;
   time_t settime, timeout;
   void (*code) (Timeout *);	/* This structure is passed to the code */
   void *data;			/* Can be anything */
};

/* Check the timeout list for any pending actions. */
extern void check_timeouts (void);

/* Add a timeout to the list to be triggered in `delay' seconds. */
extern Timeout *add_timeout (int delay, void (*code) (Timeout *));

/* Remove a timeout from the list (if it's there). */
extern void del_timeout (Timeout * t);

#endif /* TIMEOUT_H */
